/*
 * KBI.c
 *
 *  Created on: Sep 26, 2013
 *      Author: B46911
 */

#include "KBI.h"

/**********************************************************************************************
* External objects
**********************************************************************************************/


/**********************************************************************************************
* Global variables
**********************************************************************************************/
pt2FuncU8 KBI_Callback;

/**********************************************************************************************
* Constants and macros
**********************************************************************************************/


/**********************************************************************************************
* Local types
**********************************************************************************************/


/**********************************************************************************************
* Local function prototypes
*********************************************************************************************/
void KBI1_IRQHandler(void);

/**********************************************************************************************
* Local variables
**********************************************************************************************/


/**********************************************************************************************
* Local functions
**********************************************************************************************/


/**********************************************************************************************
* Global functions
**********************************************************************************************/


/***********************************************************************************************
*
* @brief    KBI_Init - Enable Keyboard interrupts on channels 24 and 25 (SW1 and SW2)
* @param    none
* @return   none
*
************************************************************************************************/  
void KBI_Init()
{
	
	SIM->SCGC |=  SIM_SCGC_KBI1_MASK; /* Enable bus clock on KBI1 */
	
	KBI1->SC = 0;  				    /* Clearing mechanism */
	KBI1->ES |= KBI_ES_KBEDG(1);    /* Polarity setting, falling edge low level ,SW1 */
	KBI1->ES |= KBI_ES_KBEDG(2);    /* Polarity setting,falling edge low level,SW2 */
	KBI1->PE |= KBI_PE_KBIPE(1);   /* Enable KBI1 channel 0 , SW1 */
	KBI1->PE |= KBI_PE_KBIPE(2);   /* Enable KBI1 channel 1 , SW2 */
	KBI1->SC = 0;  				  /* Clearing flags*/
	KBI1->SC |= KBI_SC_KBIE_MASK;  /* Enable  KBI1 Interrupts */	


	
}
/***********************************************************************************************
*
* @brief    KBI_SetCallback - Set a callback function to execute on a falling edge of an enabled KBI pin
* @param    pointer to function with an UINT8 argument
* @return   none
*
************************************************************************************************/  

void KBI_SetCallback(pt2FuncU8 ptr)
{
	KBI_Callback = ptr;	
}


/***********************************************************************************************
*
* @brief    KBI1_IRQHandler - KBI interrupt routine, calls the user callabck
* @param    none
* @return   none
*
************************************************************************************************/  
void KBI1_IRQHandler()
{
	
	KBI1->SC |= KBI_SC_KBACK_MASK;	/*Clear flag*/
	
	if((GPIOA->PDIR & GPIO_PDIR_PDI(0x100000))>>20) /* If SW1 has been pressed */ 
	{
		KBI_Callback(0);

	}
	
	if((GPIOA->PDIR & GPIO_PDIR_PDI(0x200000))>>21) /* If SW2 has been pressed */ 
	{
		KBI_Callback(1);

	}
			
	
}

